> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Host Authentication Tokens

> Lists host authentication tokens with optional filtering.

`Unary` · [`Runner Configurations`](/docs/api-reference/generated/runner-configuration/overview)

Lists host authentication tokens with optional filtering.

Use this method to:

* View all tokens
* Filter by runner or user
* Monitor token status

### Examples

* List all tokens:

  Shows all tokens with pagination.

  ```yaml theme={null}
  pagination:
    pageSize: 20
  ```

* Filter by runner:

  Lists tokens for a specific runner.

  ```yaml theme={null}
  filter:
    runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  pagination:
    pageSize: 20
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.RunnerConfigurationService/ListHostAuthenticationTokens
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.RunnerConfigurationService/ListHostAuthenticationTokens" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.pagination_pb2 as pagination_pb2
  import gitpod.v1.runner_configuration_pb2 as runner_configuration_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = runner_configuration_pb2.ListHostAuthenticationTokensRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.runner_configuration.list_host_authentication_tokens(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListHostAuthenticationTokensRequestSchema } from "@gitpod/sdk/gitpod/v1/runner_configuration_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListHostAuthenticationTokensRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.runnerConfiguration.listHostAuthenticationTokens(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListHostAuthenticationTokensRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.RunnerConfiguration.ListHostAuthenticationTokens(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListHostAuthenticationTokensRequest`

| Field        | Type                                                                     | Required | Description |
| ------------ | ------------------------------------------------------------------------ | -------- | ----------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request)                  | No       |             |
| `filter`     | [Filter](#type-gitpod-v1-list-host-authentication-tokens-request-filter) | No       |             |

## Response

`gitpod.v1.ListHostAuthenticationTokensResponse`

| Field        | Type                                                                          | Required | Description |
| ------------ | ----------------------------------------------------------------------------- | -------- | ----------- |
| `pagination` | [PaginationResponse](#type-gitpod-v1-pagination-response)                     | No       |             |
| `tokens`     | array of [HostAuthenticationToken](#type-gitpod-v1-host-authentication-token) | No       |             |

## Related types

<a id="type-gitpod-v1-host-authentication-token" />

<Accordion title="HostAuthenticationToken">
  `gitpod.v1.HostAuthenticationToken`

  | Field           | Type                                                                              | Required | Description                                                               |
  | --------------- | --------------------------------------------------------------------------------- | -------- | ------------------------------------------------------------------------- |
  | `id`            | string                                                                            | No       |                                                                           |
  | `runnerId`      | string                                                                            | No       |                                                                           |
  | `userId`        | string                                                                            | No       | **Deprecated.** Deprecated: Use principal\_id and principal\_type instead |
  | `host`          | string                                                                            | No       |                                                                           |
  | `source`        | [HostAuthenticationTokenSource](#enum-gitpod-v1-host-authentication-token-source) | No       |                                                                           |
  | `expiresAt`     | RFC 3339 timestamp                                                                | No       |                                                                           |
  | `integrationId` | string                                                                            | No       |                                                                           |
  | `scopes`        | array of string                                                                   | No       |                                                                           |
  | `subject`       | [Subject](#type-gitpod-v1-subject)                                                | No       | Subject identifies the principal (user or service account) for the token  |
</Accordion>

<a id="type-gitpod-v1-list-host-authentication-tokens-request-filter" />

<Accordion title="Filter">
  `gitpod.v1.ListHostAuthenticationTokensRequest.Filter`

  | Field       | Type   | Required | Description                                                                            |
  | ----------- | ------ | -------- | -------------------------------------------------------------------------------------- |
  | `runnerId`  | string | No       | Constraints: `string.uuid=true`.                                                       |
  | `userId`    | string | No       | **Deprecated.** Deprecated: Use principal\_id instead Constraints: `string.uuid=true`. |
  | `subjectId` | string | No       | Filter by subject (user or service account) Constraints: `string.uuid=true`.           |
</Accordion>

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-subject" />

<Accordion title="Subject">
  `gitpod.v1.Subject`

  | Field       | Type                                   | Required | Description                                                                      |
  | ----------- | -------------------------------------- | -------- | -------------------------------------------------------------------------------- |
  | `id`        | string                                 | No       | id is the UUID of the subject Constraints: `ignore=1, string.uuid=true`.         |
  | `principal` | [Principal](#enum-gitpod-v1-principal) | No       | Principal is the principal of the subject Constraints: `enum.defined_only=true`. |
</Accordion>

<a id="enum-gitpod-v1-host-authentication-token-source" />

<Accordion title="HostAuthenticationTokenSource">
  | Value                                          | Number | Description |
  | ---------------------------------------------- | -----: | ----------- |
  | `HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED` |      0 |             |
  | `HOST_AUTHENTICATION_TOKEN_SOURCE_OAUTH`       |      1 |             |
  | `HOST_AUTHENTICATION_TOKEN_SOURCE_PAT`         |      2 |             |
</Accordion>

<a id="enum-gitpod-v1-principal" />

<Accordion title="Principal">
  | Value                       | Number | Description |
  | --------------------------- | -----: | ----------- |
  | `PRINCIPAL_UNSPECIFIED`     |      0 |             |
  | `PRINCIPAL_ACCOUNT`         |      1 |             |
  | `PRINCIPAL_USER`            |      2 |             |
  | `PRINCIPAL_RUNNER`          |      3 |             |
  | `PRINCIPAL_ENVIRONMENT`     |      4 |             |
  | `PRINCIPAL_SERVICE_ACCOUNT` |      5 |             |
  | `PRINCIPAL_RUNNER_MANAGER`  |      6 |             |
</Accordion>
